using UnityEngine;
using System.Collections;

public class globalVars : MonoBehaviour {

    public static int levelDifficulty = 1;

    public static int playerScore = 0;
    public static bool levelWon = false;
    public static bool levelLost = false;
    public static int targetScore = 50;
    public static int levelScore;
    public static int totalScore;
    public static Color activeColor;
    public static bool cubeActive = false;
    public static int activeCubes = 0;
    public static int correctCubes = 0;
    public static int wrongCubes = 0;
    public static int correctInRow = 0;
    public static int potatoCount = 0;
    public static int potatoesSpawned = 0;
    public static int potatoChance = 10;
    public static float countdown;
    bool countdownRun = false;
    int countDownTime = 60;
    public static float playTime = 0;
    float colSwitchTime = 5.0f;

 


	// Use this for initialization
	void Start () {
        resetAll();
        setLevelDifficulty();
        playerScore = 0;
        activeColor = Color.yellow;
        InvokeRepeating("randomColor", colSwitchTime, colSwitchTime); //invoke 5 seconds after first invoke and then every 5 seconds
        StartCountdown(countDownTime);
	}

	// Update is called once per frame
	void Update () {
       // StartCoroutine(cubeCollectTimer(0.1f));
        if (countdown <= 0) {
        //    print("Out of time, game over!");
            levelLost = true;
           Application.LoadLevel("End");
        }
        if (playerScore >= targetScore) {
            levelScore = Mathf.CeilToInt(playerScore * countdown);
            playTime = 60 - countdown;
            countdownRun = false;

         //   print("Success! Level completed! ");
            levelWon = true;
            Application.LoadLevel("End");

        }

        if (Input.GetKeyDown("escape")) {
           Application.LoadLevel("Start");
        }
        Countdown();
	}


    IEnumerator cubeCollectTimer(float t) {
        if(cubeActive){
            print("pickup disabled");
            yield return new WaitForSeconds(t);
            cubeActive = false;
        }
    }



    void randomColor() {
          
            int colorSwitch = Mathf.FloorToInt(Random.Range(1, 4));

            if (colorSwitch == 1)
                    activeColor = Color.yellow;
            else if (colorSwitch == 2)
                    activeColor = Color.green;
            else if (colorSwitch == 3)
                    activeColor = new Color(0,0.5f,1,1); //blue

    }


    //countdown functions
    void StartCountdown(float time) {
        countdownRun = true;
        countdown = time;
    }
    void Countdown() {
        if (countdownRun) {
            countdown -= Time.deltaTime;
            //  print(countdown);
            if (countdown <= 0) {
                //Do your stuff
                countdownRun = false;
            }
        }
    }


    void setLevelDifficulty() {
        if (levelDifficulty == 1) {
            countDownTime = 60;
            targetScore = 50;
        } else if (levelDifficulty == 2) {
            countDownTime = 60;
            targetScore = 100;
        } else if (levelDifficulty == 3) {
            countDownTime = 45;
            targetScore = 125;
        } else  if (levelDifficulty == 4) {
            countDownTime = 30;
            targetScore = 150;
            colSwitchTime = 4.0f;
        } else if (levelDifficulty == 5) {
            countDownTime = 30;
            targetScore = 200;
            colSwitchTime = 4.0f;
        } else {
            countDownTime = 60;
            targetScore = 500;
            colSwitchTime = 3.0f;
        }


    }


    void resetAll(){
        playerScore = 0;
        targetScore  = 50;
        levelScore = 0;
        totalScore = 0;
        cubeActive = false;
        activeCubes = 0;
        countdownRun = false;
        countDownTime = 60;
        potatoCount = 0;
        potatoesSpawned = 0;
        correctCubes = 0;
        wrongCubes = 0;
        correctInRow = 0;
        potatoChance = 10;
        levelWon = false;
        levelLost = false;
        playTime = 0;
        colSwitchTime = 5.0f;
    }


}
